/* 
 * CSE142, Spring 1999
 * Homework 4 PART A
 * Naval & Air Traffic animation

 * NATHAN W MOORE

 * SECTION VA
 */


#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>
	/* 
	* <time.h> is included so the current time can be accessed
	* to initialize the random number generator.  If you don't
	* use random numbers (and you don't have to) you can either
	* ignore this #include or delete it.
	*/

/* CHECK LINE LENGTH!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1 */
/* CHECK LINE LENGTH!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1 */
/* CHECK LINE LENGTH!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1 */
/* CHECK LINE LENGTH!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1 */
/* CHECK LINE LENGTH!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1 */
/* CHECK LINE LENGTH!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1 */

/* Logical constants */
#define TRUE    		1
#define FALSE   		0
#define DUMMY			-1

/* Directional constants */
#define LEFT			-1
#define RIGHT 			1
#define UP				1
#define DOWN			-1

/* Column labels for animations[][] array.						*/
#define TYPE	0	/*object_type (see #define list just below	*/
					/*this one for values) */
#define X		1	/*x coordinate*/
#define Y		2	/*y coordinate*/
#define XD		3	/*x direction: LEFT or RIGHT*/
#define YD		4	/*y direction: UP or DOWN*/
#define XV		5	/*x velocity in pixels per tick w/ direction*/
#define YV		6	/*y velocity in pixels per tick w/ direction*/
#define XA		7	/*x acceleration constant in pixels per tick*/
#define YA		8	/*y acceleration constant in pixels per tick*/
#define COLOR	9	/*primary color of object					*/
	
/* Animation object types		*/
/* (used for logic control)		*/
#define SUN				0
#define CARRIER			1
#define RADAR			2
#define SUB				3
#define NEWJET			4
#define TORPEDO			5
#define CHARGE			6
#define JET				7
#define EXPLOSION		8
#define NONEXISTANT		101

/* 
 * For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.  The
 * constant FILL is used in function calls when a solid
 * shape is desired.
 */
#define FILL 0


/*
 * Symbolic constants.  Change as needed.
 */

/* Menu buttons: */

/* Height and width of buttons in pixels */
#define BUTTON_HEIGHT  	25
#define BUTTON_WIDTH 	75

/* Top-left coordinates of button palette */
#define MENU_TOP		(GP142_YMAX - 5)
#define MENU_LEFT		(-GP142_XMAX + 5)

/* Number of buttons */
#define NUM_BUTTONS 	10

/* Possible locations of mouse clicks: */

/* Mouse click in some button */
#define BUTTON_CLICK 1

/* Mouse click elsewhere */
#define OTHER_CLICK 0

/* Number of columns in array: animations[][] */
#define COLUMNS 10

/* y-coordinate of the top of the ocean in the landscape */
#define SEA_LEVEL (- 2 * (GP142_YMAX / 10))

/* carrier properties */
#define CARRIER_HEIGHT 16
#define DECK_WIDTH 120
#define TOWER_HEIGHT 18
#define TOWER_WIDTH (DECK_WIDTH / 4 )
#define TRANSEPT_HEIGHT 6
#define TRANSEPT_WIDTH 12

/* jet size & flight pattern constants */
#define JET_SIZE 36
#define MIN_JET_SPEED 10
#define HIGH_ALTITUDE (GP142_YMAX - 1.5 * JET_SIZE)
#define LOW_ALTITUDE (SEA_LEVEL + 3 * JET_SIZE)
#define FAR_RIGHT (GP142_XMAX - 1.5 * JET_SIZE)
#define FAR_LEFT (-GP142_XMAX + 1.5 * JET_SIZE)

/* submarine & torpedo dimensions */
#define SUB_LENGTH 50
#define SUB_HEIGHT 15
#define TORPEDO_LENGTH 16

/* Maximum number of vehicles that can appear in the animation */
#define MAX_ANIMATIONS 100


/*****************************************************************************

     FUNCTION PROTOTYPES

*****************************************************************************/

/* Initialize random number generator.  [Ignore or		*/
/* remove if your program doesn't use random numbers.]	*/
void initialize_random_numbers();

/* Draw the background */
void draw_landscape();

/* Draw the buttons */
void draw_buttons();

/* Return kind of mouse click (in a button, etc.) */
int  classify_mouse_click(int mouse_x, int mouse_y);

/* Process button click at location x, y.  Controls movement  */
/* of sub, firing of torpedos, plane launches, & jet color.   */
void handle_button(int mouse_x, int mouse_y,
				   int animations[MAX_ANIMATIONS][COLUMNS]);

/* Identify type of object and call appropriate function	*/
/* to update position.										*/
void move_objects(int animations[MAX_ANIMATIONS][COLUMNS]);

/* Adjust a jet's (x & y) velocities, directions, and accelerations	*/
/* based on current location on screen to keep it from flying 		*/
/* out of bounds, crashing into other objects, etc.					*/
void handle_flight(int object, int animations[MAX_ANIMATIONS][COLUMNS]);

/* drops a charge from each active jet */
void drop_charges(int animations[MAX_ANIMATIONS][COLUMNS]);

/* Check to see if any armaments should detinate and */
/* removes vehicles that are affected.				 */
void detinate(int animations[MAX_ANIMATIONS][COLUMNS]);

/* finds first of a given type in animations array */
int first_of_type(int animations[MAX_ANIMATIONS][COLUMNS], int given_type);

/* Update all vehicle x, y coordinates, given current x, y  */
/* location, direction (+1 or -1), velocity, & acceleration */
/* in pixels per tick.										*/
void update_xy(int object, int animations[MAX_ANIMATIONS][COLUMNS]);

/* create a new jet (object) */
void new_jet(int animations[MAX_ANIMATIONS][COLUMNS]);

/* create a new submarine (object) */
void new_sub(int animations[MAX_ANIMATIONS][COLUMNS]);

/* create a new carrier (object) */
void new_carrier(int animations[MAX_ANIMATIONS][COLUMNS]);

/* launches a torpedo */
void new_torpedo(int animations[MAX_ANIMATIONS][COLUMNS]);

/* drops a depth charge from a jet */
void new_charge(int animations[MAX_ANIMATIONS][COLUMNS]);
 
/* finds the distance on the screen between any two animated objects*/
int distance(int animations[MAX_ANIMATIONS][COLUMNS], int object1, int object2);

/* Identifies type of each animated object & calls the		*/
/* appropriate draw function based on type.					*/
void draw_objects(int animations[MAX_ANIMATIONS][COLUMNS]);

/* Draws each object according to new position, direction,	*/
/* color, etc. as given in animations[][] array.			*/
void draw_sun(int animations[MAX_ANIMATIONS][COLUMNS]);
void draw_sub(int animations[MAX_ANIMATIONS][COLUMNS]);
void draw_carrier(int animations[MAX_ANIMATIONS][COLUMNS]);
void draw_jet(int animations[MAX_ANIMATIONS][COLUMNS], int object);
void draw_torpedo(int animations[MAX_ANIMATIONS][COLUMNS], int object);
void draw_charge(int animations[MAX_ANIMATIONS][COLUMNS], int object);

/* Display error message if internal error is detected. */
void something_is_wrong (void);


/*****************************************************************************

     MAIN

*****************************************************************************/

/*
 * Main program contents:
 *   - Major program variables that persist throughout execution
 *   - Event loop that processes GP142 events until the user quits,
 *     and updates variables and redraws the window as needed.
 */
int main(void)
{
	/* Event handling and buttons: */
	int  quit;				/* = "user has selected quit"				*/
	int  event;				/* the most recent GP142 event				*/
	char key_pressed;		/* last keyboard character from key event	*/
	int  mouse_x, mouse_y;	/* x and y coordinates of latest mouse event*/
	int  click_kind;		/* kind of mouse click (button, etc.)		*/
	int  object;			/* used for initializing unused animations  */


	/* Information about animated objects are kept in this arrary.		*/
	/* Rows correspond to a particular object, which may or may not		*/
	/* be animated depending on user's instructions.					*/
	/* Columns correspond to labels listed in constant list above.		*/
	int animations[MAX_ANIMATIONS][COLUMNS];
	
	
	/* initialize animations array (see above chart as reference) */
		
		/* make every row in array have type NONEXISTANT		  */
		/* for logic control.									  */
		for (object = 5; object < MAX_ANIMATIONS; object++)
			animations[object][TYPE] = NONEXISTANT;			
		
		/*sun*/
		animations[SUN][TYPE] = SUN;				
		animations[SUN][X] = GP142_XMAX - 50;	
		animations[SUN][Y] = GP142_YMAX - 35;
		animations[SUN][XD] = LEFT;
		animations[SUN][YD] = FALSE;
		animations[SUN][XV] = LEFT;
		animations[SUN][YV] = FALSE;
		animations[SUN][XA] = FALSE;	
		animations[SUN][YA] = FALSE;
		animations[SUN][COLOR] = YELLOW;

		/*carrier*/
		new_carrier(animations);
				
		/*submarine*/
		new_sub(animations);
	
		/*jet*/
		new_jet(animations);
		
	/* Initialize graphics package & random numbers,	*/
	/* clear the window, turn logging off, and start	*/
	/* animation										*/
	GP142_open();
	GP142_logging(LOG_OFF);
	GP142_clear();
	GP142_animate(ANI_RUN);
	initialize_random_numbers();

		
	/* Draw initial landscape, buttons, and vehicles */
	draw_landscape();
	draw_buttons();
	draw_objects(animations);


	/*
	 * Main event loop:
	 * ---- ----- -----
	 * Wait for the next user action, decode it, and call an
	 * appropriate function to handle it.  Repeat until the
	 * user selects quit.
	 */
	quit = FALSE;
	while (!quit) {
		
		/* get next event */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_pressed);
		
		/* perform appropriate action depending on kind of event */
		switch (event) {
		case GP142_QUIT:
			/* Quit selected */
			quit = TRUE;
			break;
		case GP142_KBD:
			/* Key pressed.  Not used now.  If the program should		*/
			/* react to keyboard events, insert something appropriate	*/
			/* here.  Note that scanf CANNOT be used with GP142.		*/
			break;
		case GP142_MOUSE:
			/* Mouse click.  Determine if in a menu button	*/
			/* or elsewhere and process accordingly.		*/
			click_kind = classify_mouse_click(mouse_x, mouse_y);
			if (click_kind == BUTTON_CLICK) {
				handle_button(mouse_x, mouse_y, animations);
			} else {
				/* insert code here (and additional else-if statements) */
				/* to react to mouse clicks elsewhere on the screen */
			}
			break;
		case GP142_PERIODIC:
			/* Timer interval event.  Update everything	*/
			/* that needs to change as time advances.	*/
			move_objects(animations);
			detinate(animations);
		break;
		default:
			/* unknown event */
			break;
		}  /*end switch */
		
		/* Redraw everything */
		draw_landscape();
		draw_buttons();
		draw_objects(animations);
		
	}  /* end event loop */
		
	/* Termination: shut down graphics window and exit */
	GP142_close();
	return 0;
}  /*end main */


/*****************************************************************************

     BACKGROUND LANDSCAPE & SUN

*****************************************************************************/


/* Draw the background */
void draw_landscape(){

	/* Draw the sky */
	GP142_rectangleXY(ICE_BLUE, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, GP142_YMAX, FILL);
	
	/* Draw the ocean */
	GP142_rectangleXY(NAVY_BLUE, -GP142_XMAX, -GP142_YMAX,
		GP142_XMAX, SEA_LEVEL, FILL);
	
	/*Draw some mountains */
	GP142_triangleXY(MED_GRAY,
		-GP142_XMAX, SEA_LEVEL,
		GP142_XMAX, SEA_LEVEL,
		0, (4 * GP142_YMAX)/5 ,
		FILL);
	
	GP142_triangleXY(OLIVE,
		-( 5 * GP142_XMAX/4), SEA_LEVEL,
		(GP142_XMAX)/3  , SEA_LEVEL,
		-(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		FILL);
	
	GP142_triangleXY(FOREST_GREEN,
		-GP142_XMAX / 3 , SEA_LEVEL,
		GP142_XMAX, SEA_LEVEL,
		GP142_XMAX, (2 * GP142_YMAX)/3 ,
		FILL);
}
	
/* Draw the sun */
void draw_sun(int animations[MAX_ANIMATIONS][COLUMNS]){
	int x = animations[SUN][X];
	int y = animations[SUN][Y];
	int color = animations[SUN][COLOR];
	GP142_circleXY(color, x, y, 20);
}
	

/*****************************************************************************

     BUTTONS AND MOUSE CLICKS

*****************************************************************************/


/* Draws two sets of buttons for controlling vessels */
void draw_buttons( )
{
	int i;
	int text_offset = MENU_LEFT+8;	/* offset of button text in button */
	int font_size = 12;				/* size of button text */
	
	/* draw rectangles for each button */
	for(i = 0; i < NUM_BUTTONS; i++) {
		GP142_rectangleXY(BLACK,
			MENU_LEFT,
			MENU_TOP - i * BUTTON_HEIGHT,
			MENU_LEFT + BUTTON_WIDTH,
			MENU_TOP - (i + 1)*BUTTON_HEIGHT, 1);
	}
	
    i = MENU_TOP - (BUTTON_HEIGHT/2) - (font_size/2);
	GP142_printfXY(FOREST_GREEN, text_offset, i, font_size, "Scrammble");	

	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Repaint Jet");

	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "Bomb sub");

    i -= BUTTON_HEIGHT;
	GP142_printfXY(RED, text_offset, i, font_size, "Stop sub");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, " - Faster");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, " - Slower");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, " - Reverse");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, " - Climb");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, " - Dive");
	
	i -= BUTTON_HEIGHT;
	GP142_printfXY(BLACK, text_offset, i, font_size, "TORPEDO!");
	}

/* Classify mouse click at (mouse_x,mouse_y) and return kind */
int  classify_mouse_click(int mouse_x, int mouse_y)
{
	if ((mouse_x > MENU_LEFT) &&
		(mouse_x < MENU_LEFT + BUTTON_WIDTH) &&
		(mouse_y < MENU_TOP) &&
		(mouse_y > (MENU_TOP - NUM_BUTTONS*BUTTON_HEIGHT)))
		return BUTTON_CLICK;
	else
		return OTHER_CLICK;
}

/* Process button click at location x, y.  Update car velocity,	*/
/* direction, color, and whether traffic is moving as needed.	*/
void handle_button(int mouse_x, int mouse_y,
				   int animations[MAX_ANIMATIONS][COLUMNS]){
	
	int buttonNum;		/* number of selected button */
	int object;

	/* Complain if x coordinate couldn't be inside a button */
	if (mouse_x < MENU_LEFT || mouse_x > MENU_LEFT + BUTTON_WIDTH) {
		something_is_wrong();
		return;
	}
	
	/* Convert y coordinate to button number from top. */
	buttonNum = (MENU_TOP - mouse_y)/BUTTON_HEIGHT;	 
	
    switch(buttonNum) {
	case 0:
		/* Scrammble jet - finds the newest jet in the array,	*/
		/* starts its movement, and changes it to type JET		*/
		object = first_of_type(animations, NEWJET);
		animations[object][XA] = RIGHT;
		break;
	case 1:
        /* change jet color if it hasn't taken off yet */
		object = first_of_type(animations, NEWJET);
		if (animations[object][XA] == 0)
			animations[object][COLOR] =
             (animations[object][COLOR]+1) % MAX_COLORS;
        break;
	case 2:
		/* drop charges */
        new_charge(animations);
		break;
	case 3:
        /* stop sub */
		if (animations[SUB][XD] == LEFT)
			animations[SUB][XA] = RIGHT;
		else animations[SUB][XA] = LEFT;
		break;	
	case 4:
		/* sub velocity up */
		if (animations[SUB][XD] == LEFT)
			animations[SUB][XV] -= 1;
		else animations[SUB][XV] += 1;
        break;
	case 5:
		/* slow down sub */
		if (animations[SUB][XD] == LEFT)
			animations[SUB][XV] += 1;
		else animations[SUB][XV] -= 1;
		break;
	case 6:
		/* reverse sub direction */
		animations[SUB][XD] *= -1;
		/*if (animations[SUB][XV] != 1)
			animations[SUB][XV] /= 2;*/
		break;
	case 7:
        /* climb */
		animations[SUB][YV] += UP;
		animations[SUB][YV] += UP;
		break;
	case 8:
        /* dive */
		animations[SUB][YV] += DOWN;
		animations[SUB][YV] += DOWN;
		break;
	case 9:
        /* fire torpedo */
		new_torpedo(animations);
		break;
	default:
		/*Bad news if this is ever reached! */
		something_is_wrong();
		break;
	}
}



/*****************************************************************************

     TRAFFIC AND OTHER ANIMATED OBJECTS

*****************************************************************************/


/* Update all object x, y coordinates, given current x, y */
/* location, direction (+1 or -1), velocity, & acceleration in */
/* pixels per tick, */
void move_objects(int animations[MAX_ANIMATIONS][COLUMNS]) {
	
	int object;
	for (object = 0; object < MAX_ANIMATIONS; object ++ ) {
		
		switch(animations[object][TYPE]) {
		case SUN:
			/*sun*/
			update_xy(object, animations);
			if (animations[object][X] < -GP142_XMAX -30) {
				animations[object][X] *= -1;
				animations[object][Y] --;
			}
			break;
		case CARRIER:
			/* if carrier moves off end of screen it emerges */
			/* on other side, otherwise it just moves along  */				
			update_xy(object, animations);
			if (animations[CARRIER][XD] == LEFT && animations[CARRIER][X] <
				-GP142_XMAX - (DECK_WIDTH / 2) )
				animations[CARRIER][X] = GP142_XMAX + (DECK_WIDTH / 2);
			if (animations[CARRIER][XD] == RIGHT && animations[CARRIER][X] >
				GP142_XMAX + (DECK_WIDTH / 2) )
				animations[CARRIER][X] = -GP142_XMAX - (DECK_WIDTH / 2);
			break;
		case RADAR:
			/*radar*/
			/*may add this feature later*/
			break;
		case SUB:
			/*sub is moved & relocated if it is off the screen*/
			update_xy(object, animations);
			if (animations[SUB][XD] == LEFT && animations[SUB][X] <
				-GP142_XMAX - (SUB_LENGTH / 2) - SUB_HEIGHT)
				animations[SUB][X] = GP142_XMAX + (SUB_LENGTH / 2) + SUB_HEIGHT;
			if (animations[SUB][XD] == RIGHT && animations[SUB][X] >
				GP142_XMAX + (SUB_LENGTH / 2) + SUB_HEIGHT)
				animations[SUB][X] = -GP142_XMAX - (SUB_LENGTH / 2) - SUB_HEIGHT;
			/*velocity changed if too near the surface or bottom*/
			if (animations[SUB][Y] >= SEA_LEVEL - SUB_HEIGHT)
				animations[SUB][YV] = FALSE;
			if (animations[SUB][Y] <= -GP142_YMAX + SUB_HEIGHT)
				animations[SUB][YV] = FALSE;
			/*acceleration cancelled if sub has stopped*/
			if (animations[SUB][XV] == FALSE &&
				animations[SUB][XA] != FALSE)
				animations[SUB][XA] = FALSE;
			break;
			update_xy(object, animations);
			break;
		case TORPEDO:
			update_xy(object, animations);
			/* throttle accelerations if too torpedo moves too fast */
			if (animations[object][YV] > 5) animations[object][YA] = 0;
			if (animations[object][XV] > 4) animations[object][XA] = 0;
			/* change directions & speeds if near sea surface */
			if (animations[object][Y] > SEA_LEVEL - 15 && animations[object][YD] != FALSE){
				if (animations[object][X] - animations[CARRIER][X] > 0)
					animations[object][XD] = LEFT;
				else animations[object][XD] = RIGHT;
				animations[object][YD] = FALSE;
				animations[object][XV] = 0;
				animations[object][YV] = 0;
				animations[object][XA] = animations[object][XD];
				animations[object][YA] = FALSE;
			}
			break;
		case CHARGE:
			/* depth charge dropped from jet   */
			/* slows down if charge hits water */
			if (animations[object][Y] < SEA_LEVEL &&
				animations[object][YA] == DOWN){
				
				/*animations[object][XD] = FALSE;*/
                animations[object][YD] = DOWN;
				/*animations[object][XV] = FALSE;*/
				animations[object][YV] /= 4;
				if (animations[object][XD] == LEFT)
                    animations[object][XA] = 1;
                if (animations[object][XD] == RIGHT)
                    animations[object][XA] = -1;
                animations[object][YA] = FALSE;
			}
            /* deccelerate x movement if in water */
            if (animations[object][XD] == FALSE &&
                animations[object][XV] == FALSE)
                animations[object][XA] = FALSE;
            /* destroy if charge sinks below bottom of ocean */
            if (animations[object][Y] < -GP142_YMAX)
                animations[object][TYPE] = NONEXISTANT;
            update_xy(object, animations);
			break;
		case NEWJET:
			handle_flight(object, animations);
			update_xy(object, animations);
			break;		
		case JET:
			/*jet*/
			handle_flight(object, animations);
			update_xy(object, animations);
			break;
		case 8:
			/*explosion - may add this feature later */
			break;
		default:
			break;
		}
	}
}

/* updates x & y coordinates & velocities based on accelerations*/
void update_xy(int object, int animations[MAX_ANIMATIONS][COLUMNS]){
	
	/* make sure that speed has the same sign ( + / - )		*/
	/* as the direction */
	if (animations[object][XV] > 0 && animations[object][XD] < 0 )
		animations[object][XV] *= animations[object][XD];
	if (animations[object][XV] < 0 && animations[object][XD] > 0 )
		animations[object][XV] *= -1;
	if (animations[object][YV] > 0 && animations[object][YD] < 0 )
		animations[object][YV] *= animations[object][YD];
	if (animations[object][YV] < 0 && animations[object][YD] > 0 )
		animations[object][YV] *= -1;

	/* update velocities based on accelerations */
	animations[object][XV] += animations[object][XA];
	animations[object][YV] += animations[object][YA];
	
	/* update coordinates based on old positions & new velocities */
	animations[object][X] += animations[object][XV];
	animations[object][Y] += animations[object][YV];
}


/* Assigns starting values to a carrier.			  */	
/* Used for starting program & everytime a carrier is */
/* blown up.										  */
void new_carrier(int animations[MAX_ANIMATIONS][COLUMNS]){
	animations[CARRIER][TYPE] = CARRIER;				
	animations[CARRIER][X] = (-GP142_XMAX / 2);
	animations[CARRIER][Y] = CARRIER_HEIGHT + SEA_LEVEL;
	animations[CARRIER][XD] = RIGHT;
	animations[CARRIER][YD] = FALSE;
	animations[CARRIER][XV] = 4 * RIGHT;
	animations[CARRIER][YV] = FALSE;
	animations[CARRIER][XA] = FALSE;
	animations[CARRIER][YA] = FALSE;
	animations[CARRIER][COLOR] = MED_GRAY;
}

/* Assigns starting values to a submarine.			  */	
/* Used for starting program & everytime a sub is	  */
/* blown up.										  */
void new_sub(int animations[MAX_ANIMATIONS][COLUMNS]){
	animations[SUB][TYPE] = SUB;				
	animations[SUB][X] = GP142_XMAX / 2;	
	animations[SUB][Y] = SEA_LEVEL - 100;
	animations[SUB][XD] = LEFT;
	animations[SUB][YD] = FALSE;
	animations[SUB][XV] = LEFT;
	animations[SUB][YV] = FALSE;
	animations[SUB][XA] = FALSE;
	animations[SUB][YA] = FALSE;
	animations[SUB][COLOR] = DUSTY_PLUM;
}
	
/* Copies info of newly launched jet to a new row of array and */
/* assigns starting values to a new jet */
void new_jet(int animations[MAX_ANIMATIONS][COLUMNS]){
	int object, object_type = TRUE;
	
	/* find an unused row in animations arrary */
	object = first_of_type(animations, NONEXISTANT);
	
	/* 'create' a new jet by assigning variables to the object's*/
	/* row in animations array.									*/
	animations[object][TYPE] = NEWJET;
	animations[object][X] = animations[CARRIER][X] - (DECK_WIDTH / 2) + 2;	
	animations[object][Y] = animations[CARRIER][Y] + 6;
	animations[object][XD] = RIGHT;	
	animations[object][YD] = UP;	
	animations[object][XV] = FALSE;	
	animations[object][YV] = FALSE;	
	animations[object][XA] = FALSE;	
	animations[object][YA] = FALSE;	
	animations[object][COLOR] = RED;	
}

/* creates a new torpedo animated object */
void new_torpedo(int animations[MAX_ANIMATIONS][COLUMNS]){
	
	/*assign values for a torpedo to an used row in array*/
	int object = first_of_type(animations, NONEXISTANT);
	animations[object][TYPE] = TORPEDO;
	animations[object][X] = animations[SUB][X] + (TORPEDO_LENGTH / 2) + 10;	
	animations[object][Y] = animations[SUB][Y] + (SUB_HEIGHT / 2);
	animations[object][XD] = animations[SUB][XD];
	animations[object][YD] = UP;
	animations[object][XV] = 2 * animations[SUB][XV];
	animations[object][YV] = animations[SUB][YV];
	animations[object][XA] = 0;	
	animations[object][YA] = UP;
	animations[object][COLOR] = WHITE;
}

/* creates a new torpedo animated object emanating */
/* from each jet in the sky.                       */
void new_charge(int animations[MAX_ANIMATIONS][COLUMNS]){
	int jet;

	for (jet = FALSE; jet < MAX_ANIMATIONS; jet++){
        if (animations[jet][TYPE] == JET){

            int charge = first_of_type(animations, NONEXISTANT);
            animations[charge][TYPE] = CHARGE;
    	    animations[charge][X] = animations[jet][X];
	        animations[charge][Y] = animations[jet][Y];
	        animations[charge][XD] = animations[jet][XD];
	        animations[charge][YD] = DOWN;
	        animations[charge][XV] = animations[jet][XV] / 2;
	        animations[charge][YV] = animations[jet][YV];
	        animations[charge][XA] = 0;	
	        animations[charge][YA] = DOWN;
	        animations[charge][COLOR] = BLACK;
        }
    }
} 
 
/* Check to see if any armaments should detinate and */
/* removes vehicles accordingly.					 */
void detinate(int animations[MAX_ANIMATIONS][COLUMNS]){
	int object, torpedo, separation;

	/* Checks to see if a torpedo hit carrier: */
	for (torpedo = FALSE; torpedo < MAX_ANIMATIONS; torpedo++){
		if (animations[torpedo][TYPE] == TORPEDO){
			separation = distance(animations, CARRIER, torpedo);
			if (separation < 35){
				/* makes all torpedos & jets nonexistant if */
				/* a torpedo hit the carrier & redraws a new*/
				/* carrier & jet.							*/
				for (object = 0; object < MAX_ANIMATIONS; object++){
					if (animations[object][TYPE] == TORPEDO ||
						animations[object][TYPE] == JET ||
						animations[object][TYPE] == NEWJET ){
						animations[object][TYPE] = NONEXISTANT;
					}
				}
				new_carrier(animations);
				new_jet(animations);
			}
		}
	}
	
	/* This chunck of code intentionally commented out because */
    /* it looks silly to have planes dissapear for no apparent */
    /* reason.                                                 */
    /* Checks to see if any two jets ran into each other     */
	/* If they did, those two jets are made nonexistant. */
	/*for (jet1 = FALSE; jet1 < MAX_ANIMATIONS; jet1++){
		if (animations[jet1][TYPE] == JET){
			for (jet2 = jet1 + 1; jet2 < MAX_ANIMATIONS; jet2++){
				if (animations[jet2][TYPE] == JET){
					if (distance(animations, jet1, jet2) < 
						JET_SIZE / 4 ){
						animations[jet1][TYPE] = NONEXISTANT;
						animations[jet2][TYPE] = NONEXISTANT;
					}
				}
			}
		}
	}*/

					
    /* Checks to see if any charges hit the sub	and removes & */
	/* redraws the sub if any did.								  */
	for (object = FALSE; object < MAX_ANIMATIONS; object++){
		if (animations[object][TYPE] == CHARGE){
			if (abs(animations[object][X] - animations[SUB][X]) <
				SUB_LENGTH / 2   &&
				abs(animations[object][Y] - animations[SUB][Y]) <
				SUB_HEIGHT / 2){
				new_sub(animations);
				animations[object][TYPE] = NONEXISTANT;
			}
		}
	}
}

	


	
/* inds the distance on the screen between any two animated objects*/
int distance(int animations[MAX_ANIMATIONS][COLUMNS],
			 int object1, int object2){
	int space;
	int x1 = animations[object1][X];
	int y1 = animations[object1][Y];
	int x2 = animations[object2][X];
	int y2 = animations[object2][Y];
	space = (int) sqrt( pow(x1 - x2,2) + pow(y1 - y2,2));
	return space;
}

int first_of_type(int animations[MAX_ANIMATIONS][COLUMNS],
                  int given_type){
    int object = FALSE;
    int type;

    while (type != given_type && object < MAX_ANIMATIONS){
        type = animations[object][TYPE];
        if (type == given_type) return object;
        object++;
    }
    return DUMMY;
}

/* Adjust a jet's (x & y) velocities, directions, and accelerations	*/
/* based on current location on screen to keep it from flying 		*/
/* out of bounds, crashing into other objects, control take-off,etc */
void handle_flight(int object, int animations[MAX_ANIMATIONS][COLUMNS]){
	
	/* take-off sequence */
	if (animations[object][TYPE] == NEWJET){
		/* pre-launch position */
		if (animations[object][XV] == 0 &&
			animations[object][YV] == 0 ){
			animations[object][X] = animations[CARRIER][X] - (DECK_WIDTH / 2) + 2;
		}
		/*dip*/
        if (animations[object][X] > animations[CARRIER][X]){
            animations[object][YA] = 2*DOWN;
        }
		/*rise*/
		if (animations[object][XV] != FALSE &&
            animations[object][X] > GP142_XMAX / 3 ){
			animations[object][YA] = UP;
			animations[object][TYPE] = JET;
			new_jet(animations);
		}
		update_xy(object, animations);
	}
	
	/* note - this block of code for programming purposes only */
    /* set speed to a default if jet is flying too slowly       */
	/*if (animations[object][XV] < MIN_JET_SPEED &&
		animations[object][XV] != FALSE &&
        animations[object][TYPE] != NEWJET)
		animations[object][XV] = MIN_JET_SPEED;
	if (animations[object][YV] < MIN_JET_SPEED &&
		animations[object][YV] != FALSE)
		animations[object][YV] = MIN_JET_SPEED;*/
		
	/* vertical climb */
	if (animations[object][X] > FAR_RIGHT &&
		animations[object][XD] == RIGHT &&
        animations[object][XV] != FALSE){
		
		animations[object][XD] = LEFT;
		animations[object][YD] = UP;
		animations[object][YV] = animations[object][XV] / 2;
		animations[object][XV] = FALSE;
		animations[object][XA] = FALSE;
		animations[object][YA] = UP;
	}
			
	/* horizontal left*/
    if (animations[object][Y] > HIGH_ALTITUDE &&
		animations[object][YD] == UP){
		
		animations[object][XD] = LEFT;
		animations[object][YD] = DOWN;
		animations[object][XV] = animations[object][YV];
        animations[object][YV] = FALSE;
		animations[object][XA] = LEFT;
		animations[object][YA] = FALSE;
	}
		
	/* vertical dive*/
	if (animations[object][XD] == LEFT &&
		animations[object][X] < FAR_LEFT){
		
		animations[object][XD] = RIGHT;
		animations[object][YD] = DOWN;
		animations[object][YV] = animations[object][XV] / 2;
		animations[object][XV] = FALSE;
		animations[object][XA] = FALSE;
		animations[object][YA] = DOWN;
	}

	/* horizonatal right*/
	if (animations[object][Y] < LOW_ALTITUDE &&
		animations[object][YA] == DOWN &&
        animations[object][TYPE] != NEWJET){
		
		animations[object][XD] = RIGHT;
		animations[object][YD] = UP;
		animations[object][XV] = animations[object][YV] / 2;
		animations[object][YV] = FALSE;
		animations[object][XA] = RIGHT;
		animations[object][YA] = FALSE;
	}
}		

/* note - this function currently not used  */
/* this function may be developed later     */
/* drops a charge from each active airplane */
/*void drop_charges(int animations[MAX_ANIMATIONS][COLUMNS]){*/
	/*int charge = FALSE;
	int jet = FALSE;

	while (jet < MAX_ANIMATIONS){
		jet = first_of_type(animations, CARRIER,
							jet, MAX_ANIMATIONS);
		jet = CARRIER;

		if (jet == CARRIER) animations[SUN][COLOR] = 6;
		/* assign speeds, etc. to a new charge that */
		/* correspond to each jet */
		/*if (jet != DUMMY){
			charge = first_of_type(animations, NONEXISTANT,
							       FALSE, MAX_ANIMATIONS);

			animations[charge][TYPE] = CHARGE;				
			animations[charge][X] = animations[jet][X];	
			animations[charge][Y] = animations[jet][Y];
			animations[charge][XD] = animations[jet][XD];
			animations[charge][YD] = DOWN;
			animations[charge][XV] = animations[jet][XV];
			animations[charge][YV] = FALSE;
			animations[charge][XA] = FALSE;	
			animations[charge][YA] = DOWN;
			animations[charge][COLOR] = RED;
		}
	
	jet = MAX_ANIMATIONS;
	}
}*/

/* Draw all vehicles given their current x, y coordinates and color */
void draw_objects(int animations[MAX_ANIMATIONS][COLUMNS]) {
	int object;
	for (object = 0; object < MAX_ANIMATIONS; object ++){
		switch(animations[object][TYPE]) {
		case SUN:
			/*sun*/
			draw_sun(animations);
			break;
		case CARRIER:
			/*carrier*/
			draw_carrier(animations);
			break;
		case RADAR:
			/*radar*/
			/* ignore - I may only add this feature later */
			break;
		case SUB:
			/*submarine*/
			draw_sub(animations);
			break;	
		case NEWJET:
			/*new jet*/
			draw_jet(animations, object);
			break;
		case TORPEDO:
			/*torpedo*/
			draw_torpedo(animations, object);
			/*may add this feature later*/
			break;
		case CHARGE:
			/*depth charge*/
			draw_charge(animations, object);
            break;
		case JET:
			/*jet*/
			draw_jet(animations, object);
			break;
		case EXPLOSION:
			/*explosion */
			/*may add this feature later*/
			break;
		default:
			break;
		}
	}
}

/* Draw a single jet of the given color with horizontal */
/* center x and bottom y*/
void draw_jet(int animations[MAX_ANIMATIONS][COLUMNS], int object) {
	int x = animations[object][X];
	int y = animations[object][Y];
	int xd = animations[object][XD];	
	int yd = animations[object][YD];	
	int color = animations[object][COLOR];

	/*draw jet fuselage if it is flying right. */
	if ( xd == RIGHT && yd == UP){
		GP142_rectangleXY(color, x, y, x + 20, y + 6, FILL);
		GP142_rectangleXY(color, x + 20, y, x + 32, y + 2, FILL);
		GP142_rectangleXY(BLACK, x, y, x - 2,  y + 2, FILL);
		GP142_triangleXY(CHALK,
			x + (20 ), y + (2 ),
			x + (36 ), y + (2 ),
			x + (20 ), y + (6 ),
			FILL);
		GP142_triangleXY(BLACK,
			x + (32 ), (y ),
			x + (32 ), y + (2 ),
			x + (36 ), y + (2 ),
			FILL);
		GP142_triangleXY(color,
			(x ), y + (6 ),
			x - (2 ), y + (12 ),
			x + (8 ), y + (6  ),
			FILL);
	}
	
	/*draw jet fuselage if it is flying up. */
	if ( yd == UP && xd == LEFT){
		GP142_rectangleXY(color, x, y, x - 6, y + 20, FILL);
		GP142_rectangleXY(color, x, y + 20, x -2, y + 32, FILL);
		GP142_rectangleXY(BLACK, x, y, x - 2,  y - 2, FILL);
		GP142_triangleXY(CHALK,
			x + -2, y + 20,
			x - 6, y + 20,
			x - 2, y + 36,
			FILL);
		GP142_triangleXY(BLACK,
			x, y + 32,
			x - 2, y + 32,
			x - 2, y + 36,
			FILL);
		GP142_triangleXY(color,
			x - 6, y,
			x - 12, y - 2,
			x - 6, y + 8,
			FILL);
	}
	
	/*draw jet fuselage if it is flying left & upsidedown. */
	if ( yd == DOWN && xd == LEFT){
		GP142_rectangleXY(color, x, y, x - 20, y - 6, FILL);
		GP142_rectangleXY(color, x - 20, y, x - 32, y - 2, FILL);
		GP142_rectangleXY(BLACK, x, y, x + 2,  y - 2, FILL);
		GP142_triangleXY(CHALK,
			x - 20, y - 2,
			x - 20, y - 6,
			x - 36, y - 2,
			FILL);
		GP142_triangleXY(BLACK,
			x - 32, y,
			x - 32, y - 2,
			x - 36, y - 2,
			FILL);
		GP142_triangleXY(color,
			x, y - 6,
			x - 12, y - 6,
			x + 2, y - 12,
			FILL);
	}
	
	/*draw jet fuselage if jet is flying downwards. */
	if ( yd == DOWN && xd == RIGHT){
		GP142_rectangleXY(color, x, y, x + 6, y - 20, FILL);
		GP142_rectangleXY(color, x, y - 20, x + 2, y - 32, FILL);
		GP142_rectangleXY(BLACK, x, y, x + 2,  y + 2, FILL);
		GP142_triangleXY(CHALK,
			x + 2, y - 20,
			x + 6, y - 20,
			x + 2, y - 36,
			FILL);
		GP142_triangleXY(BLACK,
			x, y - 32,
			x + 2, y - 32,
			x + 2, y - 36,
			FILL);
		GP142_triangleXY(color,
			x + 6, y,
			x + 6, y - 8,
			x + 12, y + 2,
			FILL);
	}
	
	/*draw landing gear if jet just taking off */
	if (y < SEA_LEVEL + animations[CARRIER][Y] + 2 * JET_SIZE && 
		animations[object][XD] == RIGHT) {
		
		GP142_lineXY(BLACK,
			(x + 8), y,
			(x + 8), (y - 3),
			1);
		GP142_circleXY(BLACK,
			(x + 8), (y - 4),
			2);
		GP142_lineXY(BLACK,
			(x + 12), y,
			(x + 12), (y - 3),
			1);
		GP142_circleXY(BLACK,
			(x + 12), (y - 4),
			2);
		GP142_lineXY(BLACK,
			(x + 30), y,
			(x + 30), (y - 3),
			1);
		GP142_circleXY(BLACK,
			(x + 30), (y - 4),
			2);
	}
}


/*Draw aircraft carrier*/
void draw_carrier(int animations[MAX_ANIMATIONS][COLUMNS]){
	int color = animations[CARRIER][COLOR];
	int x = animations[CARRIER][X];
	int y = animations[CARRIER][Y];
	
	/*hull*/
	GP142_triangleXY(color,
		x - (DECK_WIDTH / 2), y,
		x - (DECK_WIDTH / 2) + CARRIER_HEIGHT, SEA_LEVEL,
		x - (DECK_WIDTH / 2) + CARRIER_HEIGHT, y,
		FILL);
	GP142_triangleXY(color,
		x + (DECK_WIDTH / 2), y,
		x + (DECK_WIDTH / 2) - CARRIER_HEIGHT, SEA_LEVEL,
		x + (DECK_WIDTH / 2) - CARRIER_HEIGHT, y,
		FILL);
	GP142_rectangleXY(color,
		x - (DECK_WIDTH / 2) + CARRIER_HEIGHT, y,
		x + (DECK_WIDTH / 2) - CARRIER_HEIGHT, SEA_LEVEL,
		FILL);
	
	/*tower*/
	GP142_rectangleXY(color,
		x - (TOWER_WIDTH / 4), TOWER_HEIGHT + y,
		x + (TOWER_WIDTH / 4), y,
		FILL);
	GP142_rectangleXY(color,
		x - (TRANSEPT_WIDTH), (y + 8),
		x + (TRANSEPT_WIDTH), (TRANSEPT_HEIGHT + y + 8),
		FILL);
	}

	
/* draw the submarine */
void draw_sub(int animations[MAX_ANIMATIONS][COLUMNS]){
	int x = animations[SUB][X];
	int y = animations[SUB][Y];
	int color = animations[SUB][COLOR];

	GP142_rectangleXY(color,
		x - (SUB_LENGTH / 2), y - (SUB_HEIGHT /2),
		x + (SUB_LENGTH / 2), y + (SUB_HEIGHT /2),
		FILL);
	GP142_circleXY(color,
		x - (SUB_LENGTH / 2), y,
	    SUB_HEIGHT / 2);
	GP142_circleXY(color,
	    x + (SUB_LENGTH / 2), y,
	    SUB_HEIGHT / 2);
	GP142_rectangleXY(color,
	    x  - (SUB_LENGTH / 4), y + (SUB_HEIGHT /2),
	    x, y + SUB_HEIGHT - 1,
	    FILL);
	}


/* draws a torpedo at its current X & Y coordinates */
void draw_torpedo(int animations[MAX_ANIMATIONS][COLUMNS], int object){
	int x = animations[object][X];
	int y = animations[object][Y];
	int color = animations[object][COLOR];

	GP142_rectangleXY(color,
		x, y,
		x + TORPEDO_LENGTH, y + 2,
		FILL);
}

/* draws a depth charge */
void draw_charge(int animations[MAX_ANIMATIONS][COLUMNS], int object){
	int x = animations[object][X];
	int y = animations[object][Y];
	int color = animations[object][COLOR];

	GP142_circleXY(color,
		x, y, 4);
}




/* end of 'traffic and other animated objects' */

/*****************************************************************************

     OTHER

*****************************************************************************/

		
/* Initialize random number generator */
/* [Ignore or delete if your program  */
/* doesn't user random numbers.] */
void initialize_random_numbers() {
	time_t t;			/* current time */
	srand (time(&t));
}

/* Display error message if internal error is detected. */
void something_is_wrong (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}

/* end of code */